class TimeSheetBean {
  bool status;
  int statusCode;
  String message;
  List<TimeSheetListBean> data;

  TimeSheetBean({this.status, this.statusCode, this.message, this.data});

  TimeSheetBean.fromJson(Map<String, dynamic> json) {
    status = json['status'];
    statusCode = json['status_code'];
    message = json['message'];
    if (json['data'] != null) {
      data = new List<TimeSheetListBean>.empty(growable: true);
      json['data'].forEach((v) {
        data.add(new TimeSheetListBean.fromJson(v));
      });
    }
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['status'] = this.status;
    data['status_code'] = this.statusCode;
    data['message'] = this.message;
    if (this.data != null) {
      data['data'] = this.data.map((v) => v.toJson()).toList();
    }
    return data;
  }
}

class TimeSheetListBean {
  int id;
  ProjectName projectName;
  String proejctDescription;
  String date;
  dynamic hours;
  Activity activity;
  OwnerId ownerId;
  String createdAt;
  String updatedAt;

  TimeSheetListBean(
      {this.id,
      this.projectName,
      this.proejctDescription,
      this.date,
      this.hours,
      this.activity,
      this.ownerId,
      this.createdAt,
      this.updatedAt});

  TimeSheetListBean.fromJson(Map<String, dynamic> json) {
    id = json['id'];
    projectName = json['project_name'] != null
        ? new ProjectName.fromJson(json['project_name'])
        : null;
    proejctDescription = json['proejct_description'];
    date = json['date'];
    hours = json['hours'];
    activity = json['activity'] != null
        ? new Activity.fromJson(json['activity'])
        : null;
    ownerId = json['owner_id'] != null
        ? new OwnerId.fromJson(json['owner_id'])
        : null;
    createdAt = json['created_at'];
    updatedAt = json['updated_at'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['id'] = this.id;
    if (this.projectName != null) {
      data['project_name'] = this.projectName.toJson();
    }
    data['proejct_description'] = this.proejctDescription;
    data['date'] = this.date;
    data['hours'] = this.hours;
    if (this.activity != null) {
      data['activity'] = this.activity.toJson();
    }
    if (this.ownerId != null) {
      data['owner_id'] = this.ownerId.toJson();
    }
    data['created_at'] = this.createdAt;
    data['updated_at'] = this.updatedAt;
    return data;
  }
}

class ProjectName {
  int id;
  String projectName;
  int projectRelease;
  int assignFrom;
  int user;
  String projectApplication;
  String projectDescription;
  String projectCode;
  String date;
  int projectStatus;
  int ownerId;
  String createdAt;
  String updatedAt;

  ProjectName(
      {this.id,
      this.projectName,
      this.projectRelease,
      this.assignFrom,
      this.user,
      this.projectApplication,
      this.projectDescription,
      this.projectCode,
      this.date,
      this.projectStatus,
      this.ownerId,
      this.createdAt,
      this.updatedAt});

  ProjectName.fromJson(Map<String, dynamic> json) {
    id = json['id'];
    projectName = json['project_name'];
    projectRelease = json['project_release'];
    assignFrom = json['assign_from'];
    user = json['user'];
    projectApplication = json['project_application'];
    projectDescription = json['project_description'];
    projectCode = json['project_code'];
    date = json['date'];
    projectStatus = json['project_status'];
    ownerId = json['owner_id'];
    createdAt = json['created_at'];
    updatedAt = json['updated_at'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['id'] = this.id;
    data['project_name'] = this.projectName;
    data['project_release'] = this.projectRelease;
    data['assign_from'] = this.assignFrom;
    data['user'] = this.user;
    data['project_application'] = this.projectApplication;
    data['project_description'] = this.projectDescription;
    data['project_code'] = this.projectCode;
    data['date'] = this.date;
    data['project_status'] = this.projectStatus;
    data['owner_id'] = this.ownerId;
    data['created_at'] = this.createdAt;
    data['updated_at'] = this.updatedAt;
    return data;
  }
}

class Activity {
  int id;
  String page;
  String key;
  String name;
  String status;
  String desc;
  String createdAt;
  String updatedAt;

  Activity(
      {this.id,
      this.page,
      this.key,
      this.name,
      this.status,
      this.desc,
      this.createdAt,
      this.updatedAt});

  Activity.fromJson(Map<String, dynamic> json) {
    id = json['id'];
    page = json['page'];
    key = json['key'];
    name = json['name'];
    status = json['status'];
    desc = json['desc'];
    createdAt = json['created_at'];
    updatedAt = json['updated_at'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['id'] = this.id;
    data['page'] = this.page;
    data['key'] = this.key;
    data['name'] = this.name;
    data['status'] = this.status;
    data['desc'] = this.desc;
    data['created_at'] = this.createdAt;
    data['updated_at'] = this.updatedAt;
    return data;
  }
}

class OwnerId {
  int id;
  String uid;
  Null fcmids;
  String name;
  String email;
  Null phone;
  String photourl;
  int roleid;
  Null status;
  String createdAt;
  String updatedAt;

  OwnerId(
      {this.id,
      this.uid,
      this.fcmids,
      this.name,
      this.email,
      this.phone,
      this.photourl,
      this.roleid,
      this.status,
      this.createdAt,
      this.updatedAt});

  OwnerId.fromJson(Map<String, dynamic> json) {
    id = json['id'];
    uid = json['uid'];
    fcmids = json['fcmids'];
    name = json['name'];
    email = json['email'];
    phone = json['phone'];
    photourl = json['photourl'];
    roleid = json['roleid'];
    status = json['status'];
    createdAt = json['created_at'];
    updatedAt = json['updated_at'];
  }

  Map<String, dynamic> toJson() {
    final Map<String, dynamic> data = new Map<String, dynamic>();
    data['id'] = this.id;
    data['uid'] = this.uid;
    data['fcmids'] = this.fcmids;
    data['name'] = this.name;
    data['email'] = this.email;
    data['phone'] = this.phone;
    data['photourl'] = this.photourl;
    data['roleid'] = this.roleid;
    data['status'] = this.status;
    data['created_at'] = this.createdAt;
    data['updated_at'] = this.updatedAt;
    return data;
  }
}
