import 'dart:io';

import 'package:bui_component/CustomAlertComponent/CustomeAlert.dart';
import 'package:example/Constants/AppColors.dart';
import 'package:example/Constants/AppStrings.dart';
import 'package:example/Screens/ModuleSelectionScreen.dart';
import 'package:example/Utils/logger.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter/widgets.dart';

class MyBaseScreen extends StatefulWidget {
  static String tag = AppStrings.BASE_SCREEN_TAG;
  static String PREFERENCES_IS_FIRST_LAUNCH_STRING =
      "PREFERENCES_IS_FIRST_LAUNCH_STRING";

  @override
  MyPlatformState createState() => MyPlatformState();
}

class MyPlatformState extends State<MyBaseScreen> {
  static State currentState;
  static int isInternetIsOn = 0;

  static int get networkValue {
    print("Network Value : " + isInternetIsOn.toString());
    if (isInternetIsOn < 0) {
      isLoggedIn().then((val) {
        if (val) {
          print("Retured val: " + val.toString());
          isInternetIsOn = 0;
        }
      });
    }
    print("Return Network value: " + isInternetIsOn.toString());
    return isInternetIsOn;
  }

  static set networkValue(int val) {
    isInternetIsOn = val;
  }

  String screenTitle = "Home";
  Widget myPlatformContainer = Container();
  static bool isLoader = false;

  @override
  void dispose() {
    super.dispose();
  }

  BuildContext bContext;

  @override
  void initState() {
    super.initState();

    //myPlatformContainer = MainWidget();
    myPlatformContainer = ModuleSelectionScreen();
  }

  @override
  Widget build(BuildContext context) {
    bContext = context;
    return SafeArea(
      child: WillPopScope(
        // ignore: missing_return
        onWillPop: _onWillPop,
        child: Scaffold(
          body: Stack(
            children: <Widget>[myPlatformContainer],
          ),
        ),
      ),
    );
  }

  Future<bool> _onWillPop() async {
    return CustomAlertBox.showCustomAlertBox(
            context: context,
            type: AppStrings.ARE_U_SURE,
            enterWidget: Text(AppStrings.EXIT),
            isPositiveEnabled: true,
            isNegativeEnabled: true,
            positiveButtonColor: AppColors.primaryColor,
            setPositiveAction: () async {
              Navigator.of(context).pop(true);
              exit(0);
            },
            positiveButtonTextColor: Colors.white) ??
        false;
  }

  static Future<bool> isLoggedIn() async {
    try {
      Logger.logMessage(Log.INFO, "Checking Internet");
      final result = await InternetAddress.lookup('google.com');
      if (result.isNotEmpty && result[0].rawAddress.isNotEmpty) {
        Logger.logMessage(Log.INFO, "Checking Internet: Yes");
        return true;
      }
    } on SocketException catch (_) {
      Logger.logMessage(Log.INFO, "Checking Internet: No");
      return false;
    }
  }
}
