
import 'dart:convert';

import 'package:bui_component/JsonFormComponent/json_schema.dart';
import 'package:flutter/material.dart';

class AllFields extends StatefulWidget {
  AllFields({Key key}) : super(key: key);

  // This widget is the home page of your application. It is stateful, meaning
  // that it has a State object (defined below) that contains fields that affect
  // how it looks.

  // This class is the configuration for the state. It holds the values (in this
  // case the title) provided by the parent (in this case the App widget) and
  // used by the build method of the State. Fields in a Widget subclass are
  // always marked "final".

  @override
  _AllFields createState() => new _AllFields();
}

class _AllFields extends State<AllFields> {
  String form = json.encode({
    'title': 'Test Form Json Schema',
    'description': 'My Description',
    'fields': [

      {
        'key': 'checkbox1',
        'type': 'checkbox',
        'label': 'Checkbox test',
        'items': [
          {
            'label': "product 1",
            'value': true,
          },
          {
            'label': "product 2",
            'value': false,
          },
          {
            'label': "product 3",
            'value': false,
          }
        ]
      },
      {
        'key': 'select1',
        'type': 'Select',
        'label': 'Select test',
        'value': 'product 1',
        'items': [
          {
            'label': "product 1",
            'value': "product 1",
          },
          {
            'label': "product 2",
            'value': "product 2",
          },
          {
            'label': "product 3",
            'value': "product 3",
          }
        ]
      },
      {
        'key':'date',
        'type':'Date',
        'label': 'Select test'
      }
    ]
  });
  dynamic response;

  @override
  Widget build(BuildContext context) {
    // This method is rerun every time setState is called, for instance as done
    // by the _incrementCounter method above.
    //
    // The Flutter framework has been optimized to make rerunning build methods
    // fast, so that you can just rebuild anything that needs updating rather
    // than having to individually change instances of widgets.
    return new Scaffold(
      appBar: new AppBar(
        // Here we take the value from the MyHomePage object that was created by
        // the App.build method, and use it to set our appbar title.
        title: new Text("All Fields"),
      ),
      body: new SingleChildScrollView(
        child: new Container(
          // Center is a layout widget. It takes a single child and positions it
          // in the middle of the parent.
          child: new Column(children: <Widget>[
            new JsonSchema(
              form: form,
              onChanged: (dynamic response) {
                this.response = response;
                print(jsonEncode(response));
              },
              actionSave: (data) {
                print(jsonEncode(data));
              },
              autovalidateMode: AutovalidateMode.always,
              buttonSave: true,
            ),
          ]),
        ),
      ),
    );
  }
}