import 'package:example/Constants/ImageAssets.dart';
import 'package:example/Screens/SignUpScreen.dart';
import 'package:example/Utils/Utility.dart';
import 'package:bui_component/ForgotScreenComponent.dart';
import 'package:bui_component/Utils/SystemUtils.dart';
import 'package:flutter/material.dart';

class ForgotScreen extends StatefulWidget {
  @override
  _ForgotScreenState createState() => _ForgotScreenState();
}

class _ForgotScreenState extends State<ForgotScreen> {
  final emailController = TextEditingController();
  var _formKey = GlobalKey<FormState>();
  BuildContext bContext;

  @override
  Widget build(BuildContext context) {
    bContext = context;
    return SafeArea(
      child: ForgotScreenComponent(
        signUpFunction: signUpFunction,
        emailController: emailController,
        sentFunction: sentFunction,
        globalKey: _formKey,
        passwordController: emailController,
        confirmPasswordController: emailController,
        imageLogo: Container(
          height: 300,
          width: MediaQuery.of(context).size.width * 0.6,
          child: CircleAvatar(
            radius: 20,
            backgroundColor: Colors.white,
            child: Container(
              padding: EdgeInsets.all(20),
              child: Image.asset(
                ImageAssets.LOGO_WITH_NAME,
                height: 100,
              ),
            ),
          ),
        ),
      ),
    );
  }

  Future<void> sentFunction() async {
    final isValid = _formKey.currentState.validate();
    if (!isValid) {
      return;
    }
    _formKey.currentState.save();

    if (SystemUtils.hasMatchEmail(emailController.text.toString())) {
      Utils.showSnackBar(bContext, "Password Send Successfully");
    }
  }

  Future<void> signUpFunction() async {
    Navigator.pushReplacement(context,
        MaterialPageRoute(builder: (BuildContext context) => SignUpScreen()));
  }
}
