import 'package:bui_component/OtpScreenComponent.dart';
import 'package:example/Constants/AppColors.dart';
import 'package:example/Constants/AppStrings.dart';
import 'package:example/Constants/ImageAssets.dart';
import 'package:example/Screens/ModuleSelectionScreen.dart';
import 'package:example/Utils/Utility.dart';
import 'package:flutter/material.dart';

class OtpScreen extends StatefulWidget {
  @override
  _OtpScreenState createState() => _OtpScreenState();
}

class _OtpScreenState extends State<OtpScreen> {
  var _formKey = GlobalKey<FormState>();
  String otpValue;

  @override
  Widget build(BuildContext context) {
    return SafeArea(
      child: Scaffold(
        body: OtpScreenComponent(
          globalKey: _formKey,
          otpSuccess: signInPage,
          backgroundColor: AppColors.APP_COLOR_PRIMARY,
          buttonColor: AppColors.APP_COLOR_PRIMARY,
          title: AppStrings.APP_NAME,
          validateCondition: validationCondition,
          imageLogo: Container(
            height: 300,
            width: MediaQuery.of(context).size.width * 0.6,
            child: CircleAvatar(
              radius: 20,
              backgroundColor: Colors.white,
              child: Container(
                padding: EdgeInsets.all(20),
                child: Image.asset(
                  ImageAssets.LOGO_WITH_NAME,
                  height: 100,
                ),
              ),
            ),
          ),
        ),
      ),
    );
  }

  Future<void> signInPage() async {
    final isValid = _formKey.currentState.validate();
    if (!isValid) {
      return;
    }
    _formKey.currentState.save();

    if (otpValue == "999999") {
      Utils.showSnackBar(context, "Successfully Login");

      Navigator.pushReplacement(
          context,
          MaterialPageRoute(
              builder: (BuildContext context) => ModuleSelectionScreen()));
    } else {
      Utils.showSnackBar(context, AppStrings.INVALID_OTP);
    }
  }

  Future<dynamic> validationCondition(String val) async {
    setState(() {
      otpValue = val;
    });
  }
}
