import 'package:example/Constants/AppColors.dart';
import 'package:example/Constants/AppStrings.dart';
import 'package:example/Constants/ImageAssets.dart';
import 'package:example/Constants/fontFamily.dart';
import 'package:example/Constants/server_url.dart';
import 'package:example/Firebase/sign_in.dart';
import 'package:example/Screens/ModuleSelectionScreen.dart';
import 'package:example/Screens/PMO/AdminPage.dart';
import 'package:example/Screens/PMO/DashBoardPage.dart';
import 'package:example/Screens/PMO/LeavePage.dart';
import 'package:example/main.dart';
import 'package:bui_component/BuiDrawerComponent/buiDrawer.dart';
import 'package:bui_component/Constants/fontSize.dart';
import 'package:bui_component/CustomAlertComponent/CustomeAlert.dart';
import 'package:firebase_auth/firebase_auth.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:shared_preferences/shared_preferences.dart';
import 'package:universal_platform/universal_platform.dart';

import 'TimeSheetPage.dart';

class MainWidgetPMO extends StatefulWidget {
  MainWidgetPMO({Key key, this.title}) : super(key: key);
  final String title;

  @override
  MainWidgetPMOState createState() => MainWidgetPMOState();
}

class MainWidgetPMOState extends State<MainWidgetPMO>
    with TickerProviderStateMixin {
  HiddenDrawerController _drawerController;
  Color primaryColor = AppColors.APP_COLOR_PRIMARY;
  Color secondaryColorTheme = AppColors.APP_COLOR_PRIMARY;
  SharedPreferences prefs;

  String roles = "Admin";
  
  static List<PopupMenuItem> popUpMenuItem= new List.empty(growable: true);

  @override
  void initState() {
    super.initState();
    colorCodePrefs();
    if(roles == AppStrings.admin){
      _drawerController = HiddenDrawerController(
        initialPage: AdminPage(
          title: 'main',
        ),
        items: [
          DrawerItem(
            text: Text(
              'Switch',
              style: TextStyle(
                  color: Colors.white,
                  fontSize: FontSize.FONT_15,
                  fontFamily: FontFamily.Gilroy,
                  fontStyle: FontStyle.normal,
                  fontWeight: FontWeight.normal),
            ),
            icon: Icon(Icons.change_circle, color: Colors.white),
            onPressed: () {
              Navigator.of(context).push(
                  MaterialPageRoute(builder: (_) => ModuleSelectionScreen()));
            },
            page: DashBoardPage(
              title: 'main',
            ),
          ),
          DrawerItem(
            text: Text(
              AppStrings.admin,
              style: TextStyle(
                  color: Colors.white,
                  fontSize: FontSize.FONT_15,
                  fontFamily: FontFamily.Gilroy,
                  fontStyle: FontStyle.normal,
                  fontWeight: FontWeight.normal),
            ),
            icon: Icon(Icons.admin_panel_settings_outlined, color: Colors.white),
            page: AdminPage(
              title: 'Admin',
            ),
          ),

          DrawerItem(
            text: Text(
              'Dashboard',
              style: TextStyle(
                  color: Colors.white,
                  fontSize: FontSize.FONT_15,
                  fontFamily: FontFamily.Gilroy,
                  fontStyle: FontStyle.normal,
                  fontWeight: FontWeight.normal),
            ),
            icon: Icon(Icons.dashboard, color: Colors.white),
            page: DashBoardPage(
              title: 'Dashboard',
            ),
          ),
          DrawerItem(
            text: Text(
              'TimeSheet',
              style: TextStyle(
                  color: Colors.white,
                  fontSize: FontSize.FONT_15,
                  fontFamily: FontFamily.Gilroy,
                  fontStyle: FontStyle.normal,
                  fontWeight: FontWeight.normal),
            ),
            icon: Icon(Icons.access_time_outlined, color: Colors.white),
            page: TimeSheetPage(
              title: "Time Sheet",
            ),
          ),
          DrawerItem(
            text: Text(
              'Leave',
              style: TextStyle(
                  color: Colors.white,
                  fontSize: FontSize.FONT_15,
                  fontFamily: FontFamily.Gilroy,
                  fontStyle: FontStyle.normal,
                  fontWeight: FontWeight.normal),
            ),
            icon: Icon(Icons.leave_bags_at_home_sharp, color: Colors.white),
            page: LeavePage(
              title: 'Leave',
            ),
          ),
        ],
      );
    }
    else {
      _drawerController = HiddenDrawerController(
        initialPage: DashBoardPage(
          title: 'main',
        ),
        items: [
          DrawerItem(
            text: Text(
              'Switch',
              style: TextStyle(
                  color: Colors.white,
                  fontSize: FontSize.FONT_15,
                  fontFamily: FontFamily.Gilroy,
                  fontStyle: FontStyle.normal,
                  fontWeight: FontWeight.normal),
            ),
            icon: Icon(Icons.change_circle, color: Colors.white),
            onPressed: () {
              Navigator.of(context).push(
                  MaterialPageRoute(builder: (_) => ModuleSelectionScreen()));
            },
            page: DashBoardPage(
              title: 'main',
            ),
          ),
          DrawerItem(
            text: Text(
              'Dashboard',
              style: TextStyle(
                  color: Colors.white,
                  fontSize: FontSize.FONT_15,
                  fontFamily: FontFamily.Gilroy,
                  fontStyle: FontStyle.normal,
                  fontWeight: FontWeight.normal),
            ),
            icon: Icon(Icons.dashboard, color: Colors.white),
            page: DashBoardPage(
              title: 'Dashboard',
            ),
          ),
          DrawerItem(
            text: Text(
              'TimeSheet',
              style: TextStyle(
                  color: Colors.white,
                  fontSize: FontSize.FONT_15,
                  fontFamily: FontFamily.Gilroy,
                  fontStyle: FontStyle.normal,
                  fontWeight: FontWeight.normal),
            ),
            icon: Icon(Icons.access_time_outlined, color: Colors.white),
            page: TimeSheetPage(
              title: "Time Sheet",
            ),
          ),
          DrawerItem(
            text: Text(
              'Leave',
              style: TextStyle(
                  color: Colors.white,
                  fontSize: FontSize.FONT_15,
                  fontFamily: FontFamily.Gilroy,
                  fontStyle: FontStyle.normal,
                  fontWeight: FontWeight.normal),
            ),
            icon: Icon(Icons.leave_bags_at_home_sharp, color: Colors.white),
            page: LeavePage(
              title: 'Leave',
            ),
          ),
        ],
      );
    }
  }

  Future<void> colorCodePrefs() async {
    prefs = await SharedPreferences.getInstance();
    String stringValue = prefs.getString(AppStrings.PRIMARY_THEME_COLOR);

    if (stringValue != null) {
      int colorCodeInt = int.parse(stringValue);
      setState(() {
        primaryColor = Color(colorCodeInt);
        this.mounted;
      });
    }
    String secondaryColor = prefs.getString(AppStrings.SECONDARY_THEME_COLOR);
    if (secondaryColor != null) {
      int colorCodeInt = int.parse(secondaryColor);
      setState(() {
        secondaryColorTheme = Color(colorCodeInt);
        this.mounted;
      });
    } else {
      setState(() {
        secondaryColorTheme = AppColors.APP_COLOR_PRIMARY;
        this.mounted;
      });
    }

    popUpMenuItem = [
      PopupMenuItem(
        height: 30,
        value: 1,
        child: Row(
          children: [
            Padding(
              padding: const EdgeInsets.all(12.0),
              child: Icon(
                Icons.settings,
                color: primaryColor ?? AppColors.APP_COLOR_BLACK,
              ),
            ),
            Text(
              AppStrings.SETTINGS,
              style: TextStyle(
                  fontWeight: FontWeight.bold,
                  fontSize: FontSize.FONT_14,
                  color: primaryColor ?? Colors.black87),
            )
          ],
        ),
      ),
      PopupMenuItem(
        value: 2,
        child: Row(
          children: [
            Padding(
              padding: const EdgeInsets.all(12.0),
              child: Icon(
                Icons.notifications_active,
                color: primaryColor ?? AppColors.APP_COLOR_BLACK,
              ),
            ),
            Text(
              AppStrings.NOTIFICATION,
              style: TextStyle(
                  fontWeight: FontWeight.bold,
                  fontSize: FontSize.FONT_14,
                  color: primaryColor ?? Colors.black87),
            )
          ],
        ),
      ),
      PopupMenuItem(
        value: 3,
        child: Row(
          children: [
            Padding(
              padding: const EdgeInsets.all(12.0),
              child: Icon(
                Icons.messenger_rounded,
                color: primaryColor ?? AppColors.APP_COLOR_BLACK,
              ),
            ),
            Text(
              AppStrings.MESSAGE,
              style: TextStyle(
                  fontWeight: FontWeight.bold,
                  fontSize: FontSize.FONT_14,
                  color: primaryColor ?? Colors.black87),
            )
          ],
        ),
      ),
      PopupMenuItem(
        value: 4,
        child: Row(
          children: [
            Padding(
              padding: const EdgeInsets.all(12.0),
              child: Icon(
                Icons.color_lens_sharp,
                color: primaryColor ?? AppColors.APP_COLOR_BLACK,
              ),
            ),
            Text(
              AppStrings.THEME,
              style: TextStyle(
                  fontWeight: FontWeight.bold,
                  fontSize: FontSize.FONT_14,
                  color: primaryColor ?? Colors.black87),
            )
          ],
        ),
      ),
      PopupMenuItem(
        value: 5,
        child: Row(
          children: [
            Padding(
              padding: const EdgeInsets.all(12.0),
              child: Icon(
                Icons.feedback_rounded,
                color: primaryColor ?? AppColors.APP_COLOR_BLACK,
              ),
            ),
            Text(
              AppStrings.FEED_BACK,
              style: TextStyle(
                  fontWeight: FontWeight.bold,
                  fontSize: FontSize.FONT_14,
                  color: primaryColor ?? Colors.black87),
            )
          ],
        ),
      ),
    ];
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      body: HiddenDrawer(
        controller: _drawerController,
        /*   header: Align(
          alignment: Alignment.bottomLeft,
          child: Column(
            children: <Widget>[
              Padding(
                padding: const EdgeInsets.all(8.0),
                child: CircleAvatar(

                  radius: 50,
                  backgroundImage: NetworkImage(
                      'https://helpx.adobe.com/content/dam/help/en/photoshop/using/convert-color-image-black-white/jcr_content/main-pars/before_and_after/image-before/Landscape-Color.jpg'),
                ),
              ),
            ],
          ),
        ),*/
        header: Column(
          mainAxisAlignment: MainAxisAlignment.spaceBetween,
          children: [
            Container(
              alignment: Alignment.topLeft,
              padding: EdgeInsets.only(left: 30),
              child:
                  /*CircleAvatar(
                radius: 50,
                backgroundImage: NetworkImage(
                    'https://helpx.adobe.com/content/dam/help/en/photoshop/using/convert-color-image-black-white/jcr_content/main-pars/before_and_after/image-before/Landscape-Color.jpg'),
              ),*/

                  CircleAvatar(
                radius: 70,
                backgroundColor: Colors.white,
                child: Container(
                  padding: EdgeInsets.all(20),
                  child: Image.asset(
                    ImageAssets.LOGO_WITH_NAME,
                    height: 150,
                  ),
                ),
              ),
            ),
          ],
        ),
        decoration: BoxDecoration(
          gradient: LinearGradient(
            begin: Alignment.topLeft,
            end: Alignment.bottomRight,
            colors: [
              /*ThemePickerScreenState.primaryColor,

              Colors.white,

              ThemePickerScreenState.primaryColor,*/
              Colors.black87,
              Colors.black87,
              Colors.black87,
            ],
            // tileMode: TileMode.repeated,
          ),
        ),
        logout: () {
          signOutFunction(context);
        },
        versionName: UniversalPlatform.isAndroid
            ? MyApp.version + AppStrings.COPY_RIGHT
            : UrlParams.AV_VALUE + AppStrings.COPY_RIGHT,
      ),
    );
  }

  Future<void> signOutFunction(BuildContext context) async {
    CustomAlertBox.showCustomAlertBox(
        context: context,
        type: AppStrings.ARE_U_SURE,
        enterWidget: Text(AppStrings.DO_U_WANT_LOGOUT),
        isPositiveEnabled: true,
        isNegativeEnabled: true,
        positiveButtonColor: AppColors.primaryColor,
        setPositiveAction: () async {
          await FirebaseAuth.instance.signOut();
          await signOutGoogle(context);
          MyApp.user_token = "";
        },
        positiveButtonTextColor: Colors.white);
  }
}
